---
schema_version: "1"
id: a0da091b1edcb658e018e772266d48c88f20ffa8bb8423ae11b77f9ec9414fc8
title: Personalization Connect REST API
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/connect-rest/connect-rest-api/references/generated-api-specs/connect-rest-api-personalization.md
canonical_url: https://developer.salesforce.com/docs/platform/connect-rest-api/references/connect-rest-api-personalization
source_site: developer.salesforce.com
content_type: documentation
content_hash: d2f2a11b749be16dddf4b3604c221ce5c8e78116169f7c65c2a34fa8fe3abe0b
products:
  - Connect REST API Developer Guide
  - Connect REST APIs
---
Personalization Connect REST API

# Personalization Connect REST API

> **Note**: The API Reference has a new three-panel layout. Browse grouped endpoints on the left, review endpoint details in the center, and access examples on the right.

**Important**: Where possible, we changed noninclusive terms to align with our company value of Equality. We maintained certain terms to avoid any effect on customer implementations.

**Version:** v67.0

## Servers

*   `https://{MyDomainName}.my.salesforce.com/services/data/v67.0` API server for your Salesforce org.
    *   ``MyDomainName (default None) Your org's My Domain name, which is used as a subdomain for the URLs that Salesforce uses to serve your org. For example, if your Lightning URL is `https://yourcompanyname.lightning.force.com`, then your My Domain name is `yourcompanyname`. Find your My Domain name and login URL on the My Domain page in Setup, or use the `getMyDomainName()` method in the Apex Domain class.``

## Tags

### Personalization Content Schema Resources

Get, create, update, and delete personalization content schemas. You use content schemas to define the structure of content delivered by a personalization point or ABn experiment. A content schema specifies the personalization type, custom attributes with default values, and the content DMO whose fields are returned at runtime.

### Personalization Engagement Signals Resources

Get, create, and delete engagement signals. Create and delete engagement signal metrics. Get, create, and delete compound metrics.

### Personalization Experimentation Resources

Create, manage, and retrieve personalization experiments.

### Personalization Points Resources

Use personalization points to create runtime entry points that combine a data space, profile data graph, and content schema to provide personalized content. You can optionally link a personalization point to an ABn experiment.

### Personalization Recommenders Resources

Create, manage, and retrieve personalization recommenders.

### Personalization Transformers Resources

Get, create, update, or delete Personalization Transformers.

The idOrName is the unique ID or API name of the transformer.

For GET, append query parameters. Query parameters can include limit, offset, and source.

## Operations

### POST Personalization Experiment Creation

`POST /personalization/abn-experiments`

Operation ID: `postABnExperimentCollection`. Tags: Personalization Experimentation Resources.

ABn Experiment Resource: Create

Create a personalization experiment.

_Available in: v65.0_

#### Parameters

*   `action` (query, string) Starts, stops, or archives the experiment.

#### Request body

Contains the details for creating a personalization experiment. **Note**: This representation inherits properties from the Personalization Experiment Base Input.

Media type: `application/json`. Schema: `ABnExperimentInput`.

#### Responses

*   **200** _Personalization Experiment_
    
    Contains details of a personalization Experiment.
    
    **Note**: This representation inherits properties from Personalization Experiment Named Base.
    
    Media type: `application/json`. Schema: `ABnExperiment`.
    

### GET Personalization Experiment List

`GET /personalization/abn-experiments/{IdOrName}`

Operation ID: `getABnExperiment`. Tags: Personalization Experimentation Resources.

ABn Experiment Resource: Read and Delete

Get information about a specific personalization experiment.

_Available in: v65.0_

#### Parameters

*   `IdOrName` (path, string, required) The ID or API name of the experiment definition.

#### Responses

*   **200** _Personalization Experiment_
    
    Contains details of a personalization Experiment.
    
    **Note**: This representation inherits properties from Personalization Experiment Named Base.
    
    Media type: `application/json`. Schema: `ABnExperiment`.
    

### DELETE Personalization Experiment Deletion

`DELETE /personalization/abn-experiments/{IdOrName}`

Operation ID: `deleteABnExperiment`. Tags: Personalization Experimentation Resources.

ABn Experiment Resource: Read and Delete

Delete a personalization experiment.

_Available in: v65.0_

#### Parameters

*   `IdOrName` (path, string, required) The ID or API name of the experiment definition.

#### Responses

*   **202** Accepted

### PATCH Personalization Experiment Update

`PATCH /personalization/abn-experiments/{IdOrName}`

Operation ID: `patchABnExperiment`. Tags: Personalization Experimentation Resources.

ABn Experiment Resource: Read and Delete

Update a personalization experiment.

_Available in: v65.0_

#### Parameters

*   `action` (query, string) Starts, stops, or archives the experiment.
*   `IdOrName` (path, string, required) The ID or API name of the experiment definition.

#### Request body

Contains the details for creating a personalization experiment. **Note**: This representation inherits properties from the Personalization Experiment Base Input.

Media type: `application/json`. Schema: `ABnExperimentInput`.

#### Responses

*   **200** _Personalization Experiment_
    
    Contains details of a personalization Experiment.
    
    **Note**: This representation inherits properties from Personalization Experiment Named Base.
    
    Media type: `application/json`. Schema: `ABnExperiment`.
    

### GET Get a list of batch decisions

`GET /personalization/batch-decisions`

Operation ID: `getPersonalizationBatchDecisionCollection`. Tags: Personalization Batch Decisions Resources.

Get a collection of personalization batch decisions.

Get a collection of batch decisions for the user.

#### Parameters

*   `filter` (query, string)
*   `limit` (query, integer)
*   `offset` (query, integer)

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `BatchDecisionCollection`.
    

### POST Create a Personalization Batch Decision

`POST /personalization/batch-decisions`

Operation ID: `postPersonalizationBatchDecisionCollection`. Tags: Personalization Batch Decisions Resources.

Get a collection of personalization batch decisions.

Create a personalization batch decision.

#### Request body

Media type: `application/json`. Schema: `BatchDecisionInput`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `BatchDecision`.
    

### GET Get a Personalization Batch Decision

`GET /personalization/batch-decisions/{idOrName}`

Operation ID: `getPersonalizationBatchDecision`. Tags: Personalization Batch Decisions Resources.

Personalization Batch Decision Resource: Read, Update, and Delete

Get a Personalization Batch Decision

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `BatchDecision`.
    

### DELETE Delete a Personalization Batch Decision

`DELETE /personalization/batch-decisions/{idOrName}`

Operation ID: `deletePersonalizationBatchDecision`. Tags: Personalization Batch Decisions Resources.

Personalization Batch Decision Resource: Read, Update, and Delete

Delete a Personalization Batch Decision

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **200** Success

### PATCH Update a Personalization Batch Decision

`PATCH /personalization/batch-decisions/{idOrName}`

Operation ID: `patchPersonalizationBatchDecision`. Tags: Personalization Batch Decisions Resources.

Personalization Batch Decision Resource: Read, Update, and Delete

Update a Personalization Batch Decision

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Request body

Media type: `application/json`. Schema: `BatchDecisionPatchInput`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `BatchDecision`.
    

### GET Get Personalization Batch Decision job history

`GET /personalization/batch-decisions/{idOrName}/jobs`

Operation ID: `getPersonalizationBatchDecisionJobHistory`. Tags: Personalization Batch Decisions Resources.

Batch Decision Resource: Get Job History Details

Get Job History

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.
*   `lastEvaluatedKey` (query, string)
*   `limit` (query, integer)

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `BatchDecisionJobCollection`.
    

### GET Retrieve a list of calculated affinities

`GET /personalization/calculated-affinities`

Operation ID: `getCalculatedAffinityCollection`. Tags: Personalization Calculated Affinity Resources.

Calculated Affinity Collection Resource: Create and list calculated affinities

Retrieve a list of calculated affinities

#### Parameters

*   `limit` (query, integer) Maximum number of calculated affinities to return
*   `offset` (query, integer) Number of records to skip

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CalculatedAffinityCollection`.
    

### POST Create a calculated affinity definition

`POST /personalization/calculated-affinities`

Operation ID: `postCalculatedAffinityCollection`. Tags: Personalization Calculated Affinity Resources.

Calculated Affinity Collection Resource: Create and list calculated affinities

Create a calculated affinity definition

#### Request body

Media type: `application/json`. Schema: `CalculatedAffinityInput`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CalculatedAffinity`.
    

### GET Retrieve a calculated affinity by ID or API name

`GET /personalization/calculated-affinities/{idOrName}`

Operation ID: `getCalculatedAffinity`. Tags: Personalization Calculated Affinity Resources.

Calculated Affinity Resource: Retrieve calculated affinity by ID or name

Retrieve a calculated affinity by ID or API name

#### Parameters

*   `idOrName` (path, string, required) The unique identifier or API name of the calculated affinity

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CalculatedAffinity`.
    

### DELETE Delete a calculated affinity

`DELETE /personalization/calculated-affinities/{idOrName}`

Operation ID: `deleteCalculatedAffinity`. Tags: Personalization Calculated Affinity Resources.

Calculated Affinity Resource: Retrieve calculated affinity by ID or name

Delete a Calculated Affinity

#### Parameters

*   `idOrName` (path, string, required) The unique identifier or API name of the calculated affinity

#### Responses

*   **200** Success

### GET Get a list of Personalization Experience Configs

`GET /personalization/external-apps/{idOrAppSourceIdOrName}/personalization-experience-configs`

Operation ID: `getPersonalizationExperienceConfigCollection`. Tags: Personalization Experience Config Resources.

Personalization Web SDK Personalization Experience Config Collection: Read & Replace

Gets a list of Personalization Experience Configs

#### Parameters

*   `idOrAppSourceIdOrName` (path, string, required) ID, app source ID, or name of the external app.
*   `dataSpaceIdOrName` (query, string)
*   `isWpmUrlRequired` (query, boolean)
*   `limit` (query, integer)
*   `offset` (query, integer)
*   `personalizationPointNameOrId` (query, string)
*   `transformerNameOrId` (query, string)

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `PersonalizationExperienceConfigCollection`.
    

### POST Create a Personalization Experience Config

`POST /personalization/external-apps/{idOrAppSourceIdOrName}/personalization-experience-configs`

Operation ID: `postPersonalizationExperienceConfigCollection`. Tags: Personalization Experience Config Resources.

Personalization Web SDK Personalization Experience Config Collection: Read & Replace

Create a Personalization Experience Config

#### Parameters

*   `idOrAppSourceIdOrName` (path, string, required) ID, app source ID, or name of the external app.
*   `disableRelatedExperiences` (query, boolean)

#### Request body

Media type: `application/json`. Schema: `PersonalizationExperienceConfigInput`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `PersonalizationExperienceConfig`.
    

### GET Get a Personalization Experience Config

`GET /personalization/external-apps/{idOrAppSourceIdOrName}/personalization-experience-configs/{name}`

Operation ID: `getPersonalizationExperienceConfig`. Tags: Personalization Experience Config Resources.

Personalization Web SDK Personalization Experience Config: Read, Update, Delete

Get a Personalization Experience Config

#### Parameters

*   `idOrAppSourceIdOrName` (path, string, required) ID, app source ID, or name of the external app.
*   `name` (path, string, required) Name of the resource.
*   `isWpmUrlRequired` (query, boolean)

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `PersonalizationExperienceConfig`.
    

### PUT Update a Personalization Experience Config

`PUT /personalization/external-apps/{idOrAppSourceIdOrName}/personalization-experience-configs/{name}`

Operation ID: `putPersonalizationExperienceConfig`. Tags: Personalization Experience Config Resources.

Personalization Web SDK Personalization Experience Config: Read, Update, Delete

Updates a Personalization Experience Config

#### Parameters

*   `idOrAppSourceIdOrName` (path, string, required) ID, app source ID, or name of the external app.
*   `name` (path, string, required) Name of the resource.
*   `disableRelatedExperiences` (query, boolean)

#### Request body

Media type: `application/json`. Schema: `PersonalizationExperienceConfigInput`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `PersonalizationExperienceConfig`.
    

### DELETE Delete a Personalization Experience Config

`DELETE /personalization/external-apps/{idOrAppSourceIdOrName}/personalization-experience-configs/{name}`

Operation ID: `deletePersonalizationExperienceConfig`. Tags: Personalization Experience Config Resources.

Personalization Web SDK Personalization Experience Config: Read, Update, Delete

Delete a Personalization Experience Config

#### Parameters

*   `idOrAppSourceIdOrName` (path, string, required) ID, app source ID, or name of the external app.
*   `name` (path, string, required) Name of the resource.

#### Responses

*   **200** Success

### POST Create a Personalization Point

`POST /personalization/personalization-points`

Operation ID: `postPersonalizationPointCollection`. Tags: Personalization Points Resources.

Personalization Point Collection Resource: Create

Create a Personalization Point

#### Request body

Media type: `application/json`. Schema: `PersonalizationPointInput`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `PersonalizationPoint`.
    

### GET Get a Personalization Point

`GET /personalization/personalization-points/{idOrName}`

Operation ID: `getPersonalizationPoint`. Tags: Personalization Points Resources.

Personalization Point Resource: Read, Update, and Delete

Get a Personalization Point

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `PersonalizationPoint`.
    

### PUT Update a Personalization Point

`PUT /personalization/personalization-points/{idOrName}`

Operation ID: `putPersonalizationPoint`. Tags: Personalization Points Resources.

Personalization Point Resource: Read, Update, and Delete

Update a Personalization Point

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Request body

Media type: `application/json`. Schema: `PersonalizationPointInput`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `PersonalizationPoint`.
    

### DELETE Delete a Personalization Point

`DELETE /personalization/personalization-points/{idOrName}`

Operation ID: `deletePersonalizationPoint`. Tags: Personalization Points Resources.

Personalization Point Resource: Read, Update, and Delete

Delete a Personalization Point

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **200** Success

### GET Personalization Recommender Collection

`GET /personalization/personalization-recommenders`

Operation ID: `getPersonalizationRecommenderCollection`. Tags: Personalization Recommenders Resources.

Personalization Recommender resource Resource: Create & Read

Get a list of personalization recommenders, optionally filtered by data space or profile data graph.

_Available in: v64.0_

#### Parameters

*   `dataSpaceIdOrName` (query, string) The ID or API name of the data space to filter by.
*   `profileDataGraphIdOrName` (query, string) The ID or API name of the profile data graph to filter by.

#### Responses

*   **200** _Personalization Recommender Collection_ Contains a collection of personalization recommenders.
    
    Media type: `application/json`. Schema: `PersonalizationRecommenderCollection`.
    

### POST Personalization Recommender Creation

`POST /personalization/personalization-recommenders`

Operation ID: `postPersonalizationRecommenderCollection`. Tags: Personalization Recommenders Resources.

Personalization Recommender resource Resource: Create & Read

Create a personalization recommender.

_Available in: v64.0_

#### Request body

Contains the details for creating a personalization recommender. **Note**: This representation inherits properties from the Personalization Recommender Base Input.

Media type: `application/json`. Schema: `PersonalizationRecommenderInput`.

#### Responses

*   **200** _Personalization Recommender_
    
    Contains details of a personalization recommender.
    
    **Note**: This representation inherits properties from Personalization Recommender Named Base.
    
    Media type: `application/json`. Schema: `PersonalizationRecommender`.
    

### GET Personalization Recommender List

`GET /personalization/personalization-recommenders/{idOrName}`

Operation ID: `getPersonalizationRecommender`. Tags: Personalization Recommenders Resources.

Personalization Recommender Resource: Read and Update

Get information about a specific personalization recommender by ID or name.

_Available in: v64.0_

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **200** _Personalization Recommender_
    
    Contains details of a personalization recommender.
    
    **Note**: This representation inherits properties from Personalization Recommender Named Base.
    
    Media type: `application/json`. Schema: `PersonalizationRecommender`.
    

### DELETE Personalization Recommender Deletion

`DELETE /personalization/personalization-recommenders/{idOrName}`

Operation ID: `deletePersonalizationRecommender`. Tags: Personalization Recommenders Resources.

Personalization Recommender Resource: Read and Update

Delete a specific personalization recommender by ID or name.

_Available in: v64.0_

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **204** _Successful Delete_ Success

### PATCH Personalization Recommender Update

`PATCH /personalization/personalization-recommenders/{idOrName}`

Operation ID: `patchPersonalizationRecommender`. Tags: Personalization Recommenders Resources.

Personalization Recommender Resource: Read and Update

Update a specific personalization recommender by ID or name.

_Available in: v65.0_

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Request body

Contains the details for editing a personalization recommender. **Note**: This representation inherits properties from the Personalization Recommender Base Patch Input.

Media type: `application/json`. Schema: `PersonalizationRecommenderPatchInput`.

#### Responses

*   **200** _Personalization Recommender_
    
    Contains details of a personalization recommender.
    
    **Note**: This representation inherits properties from Personalization Recommender Named Base.
    
    Media type: `application/json`. Schema: `PersonalizationRecommender`.
    

### GET Personalization Recommender Jobs

`GET /personalization/personalization-recommenders/{idOrName}/jobs`

Operation ID: `getPersonalizationJobHistory`. Tags: Personalization Recommenders Resources.

Recommender Resource: Get Job History Details

Get jobs associated with a specific personalization recommender.

_Available in: v63.0_

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.
*   `limit` (query, integer)
*   `offset` (query, integer)

#### Responses

*   **200** _Personalization Recommender Job Collection_ Contains a collection of personalization recommender jobs.
    
    Media type: `application/json`. Schema: `PersonalizationRecommenderJobCollection`.
    

### POST Create a Personalization Schema

`POST /personalization/personalization-schemas`

Operation ID: `postPersonalizationSchemaCollection`. Tags: Personalization Content Schema Resources.

Personalization Schema Resource: Create

Create a Personalization Schema

#### Request body

Media type: `application/json`. Schema: `PersonalizationSchemaInput`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `PersonalizationSchema`.
    

### GET Get a Personalization Schema

`GET /personalization/personalization-schemas/{idOrName}`

Operation ID: `getPersonalizationSchema`. Tags: Personalization Content Schema Resources.

Personalization Schema: Read, Update, and Delete

Get a Personalization Schema

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `PersonalizationSchema`.
    

### DELETE Delete a Personalization Schema

`DELETE /personalization/personalization-schemas/{idOrName}`

Operation ID: `deletePersonalizationSchema`. Tags: Personalization Content Schema Resources.

Personalization Schema: Read, Update, and Delete

Delete a Personalization Schema

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **200** Success

### PATCH Update a Personalization Schema

`PATCH /personalization/personalization-schemas/{idOrName}`

Operation ID: `patchPersonalizationSchema`. Tags: Personalization Content Schema Resources.

Personalization Schema: Read, Update, and Delete

Update a Personalization Schema

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Request body

Media type: `application/json`. Schema: `PersonalizationSchemaInput`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `PersonalizationSchema`.
    

### POST Engagement Signal Compound Metrics

`POST /personalization/compound-metrics`

Operation ID: `postEngagementSignalCompoundMetricCollection`. Tags: Personalization Engagement Signals Resources.

Engagement Signal Compound Metric Collection Resource

Create Engagement Signal Compound Metrics.

_Available in: v64.0_

#### Alternate paths

*   `/personalization/compound-metrics/{compoundMetricIdOrName}` - By Compound Metric ID Or Name

#### Request body

Request body for creating an Engagement Signal Compound Metric.

Media type: `application/json`. Schema: `EngagementSignalCompoundMetricInput`.

_Example: example\_1_ Payload 1

```
{
  "numeratorMetric": {
    "engagementSignalName": "EmailEngagement",
    "engagementSignalMetricName": "Emails_Interacted"
  },
  "denominatorMetric": {
    "engagementSignalName": "EmailEngagement",
    "engagementSignalMetricName": "Emails_Sent"
  },
  "description": "Email click through rate",
  "name": "MyCompoundMetric",
  "label": "MyCompoundMetric",
  "operator": "RATIO"
}
```

#### Responses

*   **200** _Engagement Signal Compound Metric_ Response body for an Engagement Signal Compound Metric.
    
    Media type: `application/json`. Schema: `EngagementSignalCompoundMetric`.
    
    _Example: example\_1_ Payload 1
    
    This example shows a sample response with details of an engagement signal compound metric.
    
    ```
    {
      "id": "2H0xx0000004CBkCAX",
      "name": "MyCompoundMetric",
      "label": "MyCompoundMetric",
      "description": "Email click through rate",
      "operator": "RATIO",
      "numeratorMetric": {
        "engagementSignalName": "EmailEngagement",
        "engagementSignalMetricName": "Emails_Interacted"
      },
      "denominatorMetric": {
        "engagementSignalName": "EmailEngagement",
        "engagementSignalMetricName": "Emails_Sent"
      },
      "url": "/services/data/v67.0/personalization/compound-metrics/2H0xx0000004CBkCAX"
    }
    ```
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for POST method.

POST https://yourInstance.salesforce.com/services/data/v67.0/personalization/compound-metrics
Content-Type: application/json

{
  "numeratorMetric": {
    "engagementSignalName": "EmailEngagement",
    "engagementSignalMetricName": "Emails_Interacted"
  },
  "denominatorMetric": {
    "engagementSignalName": "EmailEngagement",
    "engagementSignalMetricName": "Emails_Sent"
  },
  "description": "Email click through rate",
  "name": "MyCompoundMetric",
  "label": "MyCompoundMetric",
  "operator": "RATIO"
}
```

### GET Engagement Signal Compound Metrics

`GET /personalization/compound-metrics/{compoundMetricIdOrName}`

Operation ID: `getEngagementSignalCompoundMetric`. Tags: Personalization Engagement Signals Resources.

Engagement Signal Compound Metric Resource

Get Engagement Signal Compound Metrics.

_Available in: v64.0_

#### Alternate paths

*   `/personalization/compound-metrics/{compoundMetricIdOrName}` - By Compound Metric ID Or Name

#### Parameters

*   `compoundMetricIdOrName` (path, string, required) ID or name of the compound metric.

#### Responses

*   **200** _Engagement Signal Compound Metric_ Response body for an Engagement Signal Compound Metric.
    
    Media type: `application/json`. Schema: `EngagementSignalCompoundMetric`.
    
    _Example example\_1: same as POST /personalization/compound-metrics 200 response._ Payload 1
    
    This example shows a sample response with details of an engagement signal compound metric.
    
    _Example: example\_1_ Payload 1
    
    This example shows a sample response with details of an engagement signal compound metric.
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for GET and DELETE methods.

https://yourInstance.salesforce.com/services/data/v67.0/personalization/compound-metrics/2H0xx0000004CBkCAX
```

### DELETE Engagement Signal Compound Metrics

`DELETE /personalization/compound-metrics/{compoundMetricIdOrName}`

Operation ID: `deleteEngagementSignalCompoundMetric`. Tags: Personalization Engagement Signals Resources.

Engagement Signal Compound Metric Resource

Delete Engagement Signal Compound Metrics.

_Available in: v64.0_

#### Alternate paths

*   `/personalization/compound-metrics/{compoundMetricIdOrName}` - By Compound Metric ID Or Name

#### Parameters

*   `compoundMetricIdOrName` (path, string, required) ID or name of the compound metric.

#### Responses

*   **200** Success

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for GET and DELETE methods.

https://yourInstance.salesforce.com/services/data/v67.0/personalization/compound-metrics/2H0xx0000004CBkCAX
```

### GET Engagement Signals

`GET /personalization/engagement-signals`

Operation ID: `getEngagementSignalCollection`. Tags: Personalization Engagement Signals Resources.

Engagement Signal Collection Resource

List and get Engagement Signals.

_Available in: v63.0_

The query parameters can include the API name of the data space, the API name of the profile data graph, the API name of the item data graph, a limit for the number of engagement signals returned, and the number of engagement signals to skip before the return.

#### Alternate paths

*   `/personalization/engagement-signals/{idOrName}` - By ID Or Name

#### Parameters

*   `dataspaceName` (query, string)
    
    API name of the Data Space to filter by.
    
    _Available in: v63.0_
    
*   `itemDataGraphName` (query, string)
    
    API name of the Item Data Graph to filter by.
    
    _Available in: v66.0_
    
*   `limit` (query, integer)
    
    Maximum number of items to return.
    
    _Available in: v63.0_
    
*   `offset` (query, integer)
    
    Number of items to skip before starting to collect the result set.
    
    _Available in: v63.0_
    
*   `profileDataGraphName` (query, string)
    
    API name of the Profile Data Graph to filter by.
    
    _Available in: v63.0_
    

#### Responses

*   **200** _Engagement Signal_ Response body for an Engagement Signal.
    
    Media type: `application/json`. Schema: `EngagementSignalCollection`.
    
    _Example: example\_1_ Payload 1
    
    This example shows a sample response to create an engagement signal.
    
    ```
    {
      "id": "1H0xx0000004CAeCAM",
      "name": "EmailClicks",
      "label": "Email Clicks",
      "objectName": "Email_Engagement__dlm",
      "dataSpaceName": "default",
      "timestampField": {
        "objectName": "Email_Engagement__dlm",
        "name": "CreatedDate__c",
        "label": "Created Date"
      },
      "userIdField": {
        "objectName": "Email_Engagement__dlm",
        "name": "IndividualId__c",
        "label": "Individual"
      },
      "uniqueIdentifier": {
        "objectName": "Email_Engagement__dlm",
        "name": "Id__c",
        "label": "Id"
      },
      "catalogIdField": {
        "objectName": "Email_Engagement__dlm",
        "name": "CampaignId__c",
        "label": "Campaign"
      },
      "filterGroups": [
        {
          "conjunctiveOperator": "And",
          "filters": [
            {
              "action": "Includes",
              "operator": "Equals",
              "field": {
                "objectName": "Email_Engagement__dlm",
                "name": "EngagementTypeId__c",
                "label": "Engagement Type"
              },
              "values": [
                "CLICK"
              ]
            }
          ]
        }
      ],
      "metrics": [
        {
          "id": "1H0xx0000004CAeCAZ",
          "name": "Clicks_Count",
          "aggregateFunction": "Count",
          "field": {
            "objectName": "Email_Engagement__dlm",
            "name": "Id__c",
            "label": "Id"
          }
        }
      ]
    }
    ```
    
    _Example: example\_2_ Payload 2
    
    This example shows a sample response to get a single engagement signal.
    
    ```
    {
      "id": "1H0xx0000004CAeCAM",
      "name": "EmailClicks",
      "label": "Email Clicks",
      "objectName": "Email_Engagement__dlm",
      "dataSpaceName": "default"
    }
    ```
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for GET (collection) method.

GET https://yourInstance.salesforce.com/services/data/v67.0/personalization/engagement-signals?dataspaceName=default&profileDataGraphName=validProfileDG&itemDataGraphName=validItemDG&batchSize=25&offset=0
```

### POST Engagement Signals

`POST /personalization/engagement-signals`

Operation ID: `postEngagementSignalCollection`. Tags: Personalization Engagement Signals Resources.

Engagement Signal Collection Resource

Create Engagement Signals.

_Available in: v63.0_

The query parameters can include the API name of the data space, the API name of the profile data graph, the API name of the item data graph, a limit for the number of engagement signals returned, and the number of engagement signals to skip before the return.

#### Alternate paths

*   `/personalization/engagement-signals/{idOrName}` - By ID Or Name

#### Request body

Request body for creating an Engagement Signal.

Media type: `application/json`. Schema: `EngagementSignalInput`.

_Example: example\_1_ Payload 1

```
{
  "name": "EmailClicks",
  "label": "Email Clicks",
  "objectName": "Email_Engagement__dlm",
  "dataSpaceName": "default",
  "timestampField": {
    "objectName": "Email_Engagement__dlm",
    "name": "CreatedDate__c"
  },
  "userIdField": {
    "objectName": "Email_Engagement__dlm",
    "name": "IndividualId__c"
  },
  "uniqueIdentifierField": {
    "objectName": "Email_Engagement__dlm",
    "name": "Id__c"
  },
  "catalogIdField": {
    "objectName": "Email_Engagement__dlm",
    "name": "CampaignId__c"
  },
  "filterGroups": {
    "filterGroups": [
      {
        "conjunctiveOperator": "And",
        "filters": [
          {
            "action": "Includes",
            "operator": "Equals",
            "field": {
              "objectName": "Email_Engagement__dlm",
              "name": "EngagementTypeId__c"
            },
            "values": [
              "CLICK"
            ]
          }
        ]
      }
    ]
  },
  "metrics": {
    "metrics": [
      {
        "name": "Clicks_Count",
        "aggregateFunction": "Count",
        "field": {
          "objectName": "Email_Engagement__dlm",
          "name": "Id__c"
        }
      }
    ]
  }
}
```

#### Responses

*   **200** _Engagement Signal_ Response body for an Engagement Signal.
    
    Media type: `application/json`. Schema: `EngagementSignal`.
    
    _Example example\_1: same as GET /personalization/engagement-signals 200 response._ Payload 1
    
    This example shows a sample response to create an engagement signal.
    
    _Example: example\_1_ Payload 1
    
    This example shows a sample response to create an engagement signal.
    
    _Example: example\_2_ Payload 2
    
    This example shows a sample response to get a single engagement signal.
    
    ```
    {
      "id": "1H0xx0000004CAeCAM",
      "name": "EmailClicks",
      "label": "Email Clicks",
      "objectName": "Email_Engagement__dlm",
      "dataSpaceName": "default"
    }
    ```
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for POST method.

POST https://yourInstance.salesforce.com/services/data/v67.0/personalization/engagement-signals
Content-Type: application/json

{
  "name": "EmailClicks",
  "label": "Email Clicks",
  "objectName": "Email_Engagement__dlm",
  "dataSpaceName": "default",
  "timestampField": {
    "objectName": "Email_Engagement__dlm",
    "name": "CreatedDate__c"
  },
  "userIdField": {
    "objectName": "Email_Engagement__dlm",
    "name": "IndividualId__c"
  },
  "uniqueIdentifierField": {
    "objectName": "Email_Engagement__dlm",
    "name": "Id__c"
  },
  "catalogIdField": {
    "objectName": "Email_Engagement__dlm",
    "name": "CampaignId__c"
  },
  "filterGroups": {
    "filterGroups": [
      {
        "conjunctiveOperator": "And",
        "filters": [
          {
            "action": "Includes",
            "operator": "Equals",
            "field": {
              "objectName": "Email_Engagement__dlm",
              "name": "EngagementTypeId__c"
            },
            "values": [
              "CLICK"
            ]
          }
        ]
      }
    ]
  },
  "metrics": {
    "metrics": [
      {
        "name": "Clicks_Count",
        "aggregateFunction": "Count",
        "field": {
          "objectName": "Email_Engagement__dlm",
          "name": "Id__c"
        }
      }
    ]
  }
}
```

### GET Engagement Signals (By ID Or Name)

`GET /personalization/engagement-signals/{idOrName}`

Operation ID: `getEngagementSignal`. Tags: Personalization Engagement Signals Resources.

Engagement Signal Resource: Get and Delete

_Available in: v63.0_

Alternate path for `Engagement Signals`. Variant: By ID Or Name. Canonical documentation path: `/personalization/engagement-signals`.

#### Parameters

*   `dataspaceName` (query, string)
    
    API name of the Data Space to filter by.
    
    _Available in: v63.0_
    
*   `profileDataGraphName` (query, string)
    
    API name of the Profile Data Graph to filter by.
    
    _Available in: v63.0_
    
*   `itemDataGraphName` (query, string)
    
    API name of the Item Data Graph to filter by.
    
    _Available in: v66.0_
    
*   `limit` (query, integer)
    
    Maximum number of items to return.
    
    _Available in: v63.0_
    
*   `offset` (query, integer)
    
    Number of items to skip before starting to collect the result set.
    
    _Available in: v63.0_
    
*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **200** _Engagement Signal_ Response body for an Engagement Signal.
    
    Media type: `application/json`. Schema: `EngagementSignal`.
    
    _Example example\_1: same as GET /personalization/engagement-signals 200 response._ Payload 1
    
    This example shows a sample response to create an engagement signal.
    
    _Example: example\_1_ Payload 1
    
    This example shows a sample response to create an engagement signal.
    
    _Example: example\_2_ Payload 2
    
    This example shows a sample response to get a single engagement signal.
    
    ```
    {
      "id": "1H0xx0000004CAeCAM",
      "name": "EmailClicks",
      "label": "Email Clicks",
      "objectName": "Email_Engagement__dlm",
      "dataSpaceName": "default"
    }
    ```
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for GET (single) and DELETE
# methods.

https://yourInstance.salesforce.com/services/data/v67.0/personalization/engagement-signals/1H0xx0000004CAeCAM
```

### DELETE Engagement Signals

`DELETE /personalization/engagement-signals/{idOrName}`

Operation ID: `deleteEngagementSignal`. Tags: Personalization Engagement Signals Resources.

Engagement Signal Resource: Get and Delete

Delete Engagement Signals.

_Available in: v63.0_

The query parameters can include the API name of the data space, the API name of the profile data graph, the API name of the item data graph, a limit for the number of engagement signals returned, and the number of engagement signals to skip before the return.

#### Alternate paths

*   `/personalization/engagement-signals/{idOrName}` - By ID Or Name

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **200** _Engagement Signal_ Response body for an Engagement Signal.
    
    Media type: `application/json`.
    
    _Example example\_1: same as GET /personalization/engagement-signals 200 response._ Payload 1
    
    This example shows a sample response to create an engagement signal.
    
    _Example: example\_1_ Payload 1
    
    This example shows a sample response to create an engagement signal.
    
    _Example: example\_2_ Payload 2
    
    This example shows a sample response to get a single engagement signal.
    
    ```
    {
      "id": "1H0xx0000004CAeCAM",
      "name": "EmailClicks",
      "label": "Email Clicks",
      "objectName": "Email_Engagement__dlm",
      "dataSpaceName": "default"
    }
    ```
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for GET (single) and DELETE
# methods.

https://yourInstance.salesforce.com/services/data/v67.0/personalization/engagement-signals/1H0xx0000004CAeCAM
```

### POST Engagement Signal Metrics

`POST /personalization/engagement-signals/{idOrName}/metrics`

Operation ID: `postEngagementSignalMetricCollection`. Tags: Personalization Engagement Signals Resources.

Engagement Signal Metric Collection Resource

Create Engagement Signal Metrics for an Engagement Signal.

_Available in: v64.0_

#### Alternate paths

*   `/personalization/engagement-signals/{idOrName}/metrics/{idOrName}` - By ID Or Name and ID Or Name

#### Parameters

*   `idOrName` (path, string, required) ID or name of the resource.

#### Request body

Request body for creating an Engagement Signal Metric.

Media type: `application/json`. Schema: `EngagementSignalMetricInput`.

_Example: example\_1_ Payload 1

```
{
  "name": "metricName",
  "field": {
    "objectName": "Engagement_Signal_DMO__dlm",
    "name": "Unique_Identifier__c"
  },
  "aggregateFunction": "Count"
}
```

#### Responses

*   **200** _Engagement Signal Metric_ Response body for an Engagement Signal Metric.
    
    Media type: `application/json`. Schema: `EngagementSignalMetric`.
    
    _Example: example\_1_ Payload 1
    
    This example shows a sample response with details of an engagement signal metric.
    
    ```
    {
      "id": "1H0xx0000004CAeCAZ",
      "name": "metricName",
      "field": {
        "objectName": "Engagement_Signal_DMO__dlm",
        "name": "Unique_Identifier__c",
        "label": "Unique Identifier"
      },
      "aggregateFunction": "Count"
    }
    ```
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for POST method.

POST https://yourInstance.salesforce.com/services/data/v67.0/personalization/engagement-signals/1H0xx0000004CAeCAM/metrics
Content-Type: application/json

{
  "name": "metricName",
  "field": {
    "objectName": "Engagement_Signal_DMO__dlm",
    "name": "Unique_Identifier__c"
  },
  "aggregateFunction": "Count"
}
```

### DELETE Engagement Signal Metrics

`DELETE /personalization/engagement-signals/{idOrName}/metrics/{engagementSignalMetricId}`

Operation ID: `deleteEngagementSignalMetric`. Tags: Personalization Engagement Signals Resources.

Engagement Signal Metric Resource: Delete

Delete Engagement Signal Metrics for an Engagement Signal.

_Available in: v64.0_

#### Alternate paths

*   `/personalization/engagement-signals/{idOrName}/metrics/{idOrName}` - By ID Or Name and ID Or Name

#### Parameters

*   `engagementSignalMetricId` (path, string, required) ID of the engagement signal metric.
*   `idOrName` (path, string, required) ID or name of the resource.

#### Responses

*   **200** Success

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for DELETE method.

DELETE https://yourInstance.salesforce.com/services/data/v67.0/personalization/engagement-signals/1H0xx0000004CAeCAM/metrics/metricname
```

### GET Personalization Transformers

`GET /personalization/external-apps/transformer`

Operation ID: `getTransformer`. Tags: Personalization Transformers Resources.

The api resource for getting, updating and deleting a single transformer.

Get Personalization Transformers.

_Available in: v66.0_

#### Parameters

*   `idOrName` (query, string, required)
    
    Unique ID or API name of the personalization transformer to retrieve, update, or delete.
    
    _Available in: v66.0_
    

#### Responses

*   **200** _Transformer_ Response body for a single personalization transformer.
    
    Media type: `application/json`. Schema: `Transformer`.
    
    _Example: example\_1_ Transformer
    
    ```
    {
      "channel": "WebApp",
      "createdById": "005SB000007airJYAQ",
      "createdDate": "2026-02-25T16:48:45.000Z",
      "dataConnectors": [
        {
          "appIdentifier": "ed38623e-eae3-48f3-a77e-4e9b9088ebfe",
          "id": "0jaSB0000000PBJYA2",
          "name": "Test_Web_Integration_ed38623e_eae3_48f3_a77e_4e9b9088ebfe",
          "streamingAppDataConnectorType": "WebApp"
        }
      ],
      "dataSpace": "default",
      "description": null,
      "id": "7PTSB00000070ZZ4AY",
      "isEnabled": true,
      "label": "RecsHardCodedTransformer",
      "lastModifiedById": "005SB000007airJYAQ",
      "lastModifiedDate": "2026-02-25T16:49:07.000Z",
      "name": "RecsHardCodedTransformer",
      "publishedDate": "2026-02-25T16:49:07.000Z",
      "schemaReference": null,
      "substitutionDefinitions": {},
      "transformerCategory": "EmbeddedContent",
      "transformerType": "Handlebars",
      "transformerTypeDetails": {
        "componentName": null,
        "disableAutoInjectionOfEngagementAttributes": false,
        "html": "<div className=\"mb-4 mt-4\"><h1>Products</h1>..."
      }
    }
    ```
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for GET (single), PUT, and
# DELETE methods.

https://yourInstance.salesforce.com/services/data/v67.0/personalization/external-apps/transformer?idOrName=0H0xx0000004ABCAA
```

### PUT Personalization Transformers

`PUT /personalization/external-apps/transformer`

Operation ID: `updateTransformer`. Tags: Personalization Transformers Resources.

The api resource for getting, updating and deleting a single transformer.

Create and update Personalization Transformers.

_Available in: v66.0_

#### Parameters

*   `idOrName` (query, string, required)
    
    Unique ID or API name of the personalization transformer to retrieve, update, or delete.
    
    _Available in: v66.0_
    

#### Request body (required)

Request body for creating or updating a Personalization Transformer.

_Available in: v66.0_

Media type: `application/json`. Schema: `TransformerInput`.

_Example: example\_1_ Payload 1

```
{
  "name": "MyTransformer",
  "label": "My Transformer",
  "description": "Handlebars transformer for web content",
  "dataConnectors": [
    "connectorId1"
  ],
  "channel": "WebApp",
  "isEnabled": true,
  "transformerType": "Handlebars",
  "substitutionDefinitions": {
    "titleKey": {
      "label": "Banner title",
      "configType": "Static",
      "defaultValue": "Welcome",
      "overridable": true,
      "required": false
    }
  },
  "transformerTypeDetails": {
    "html": "<div>{{content}}</div>",
    "disableAutoInjectionOfEngagementAttributes": false,
    "script": "",
    "componentName": ""
  }
}
```

#### Responses

*   **200** _Transformer_ Response body for a single personalization transformer.
    
    Media type: `application/json`. Schema: `Transformer`.
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for GET (single), PUT, and
# DELETE methods.

https://yourInstance.salesforce.com/services/data/v67.0/personalization/external-apps/transformer?idOrName=0H0xx0000004ABCAA
Content-Type: application/json

{
  "name": "MyTransformer",
  "label": "My Transformer",
  "description": "Handlebars transformer for web content",
  "dataConnectors": [
    "connectorId1"
  ],
  "channel": "WebApp",
  "isEnabled": true,
  "transformerType": "Handlebars",
  "substitutionDefinitions": {
    "titleKey": {
      "label": "Banner title",
      "configType": "Static",
      "defaultValue": "Welcome",
      "overridable": true,
      "required": false
    }
  },
  "transformerTypeDetails": {
    "html": "<div>{{content}}</div>",
    "disableAutoInjectionOfEngagementAttributes": false,
    "script": "",
    "componentName": ""
  }
}
```

### DELETE Personalization Transformers

`DELETE /personalization/external-apps/transformer`

Operation ID: `deleteTransformer`. Tags: Personalization Transformers Resources.

The api resource for getting, updating and deleting a single transformer.

Delete Personalization Transformers.

_Available in: v66.0_

#### Parameters

*   `idOrName` (query, string, required)
    
    Unique ID or API name of the personalization transformer to retrieve, update, or delete.
    
    _Available in: v66.0_
    

#### Responses

*   **204** _Successful Delete_ Success

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for GET (single), PUT, and
# DELETE methods.

https://yourInstance.salesforce.com/services/data/v67.0/personalization/external-apps/transformer?idOrName=0H0xx0000004ABCAA
```

### GET Personalization Transformers Collection

`GET /personalization/external-apps/transformers`

Operation ID: `getTransformers`. Tags: Personalization Transformers Resources.

The api resource for getting and creating transformers.

Get Personalization Transformers.

_Available in: v66.0_

#### Parameters

*   `channelType` (query, string) Retrieve only the Personalization Transformers associated with the specified channel.
*   `connectorNameOrId` (query, string) Retrieve only the Personalization Transformers associated with the specified DataCloud's StreamingAppDataConnector.
*   `dataSpaceIdOrName` (query, string) Id or Name of the DataSpace.
*   `isDataConnectorAttached` (query, boolean) Filter transformers by data connector attachment status. When false, returns transformers not attached to any data connector. Can be combined with connectorNameOrId to get transformers matching that connector OR unattached transformers.
*   `isEnabled` (query, boolean) Retrieve only the Personalization Transformers which are enabled.
*   `limit` (query, integer)
    
    Limits the number of personalization transformers returned. The default is 50 and the value must be between 1 and 299. The list is sorted by name.
    
    _Available in: v66.0_
    
*   `offset` (query, integer)
    
    Number of personalization transformers to skip when retrieving the list. The default is 0 and the value must be between 0 and the number of personalization transformers. The list is sorted by name.
    
    _Available in: v66.0_
    
*   `schemaReference` (query, string) Retrieve only the Personalization Transformers associated with the specified Personalization schema reference.
*   `source` (query, string)
    
    Source of the personalization transformers to retrieve. Values: `{Global}` , `{Organization}` . Default is `{Organization}` .
    
    _Available in: v66.0_
    
*   `transformerCategory` (query, string) Retrieve only the Personalization Transformers associated with the specified Personalization Transformer Category.
*   `transformerType` (query, TransformerTypeEnum) Retrieve only the Personalization Transformers associated with the specified transformer type.

#### Responses

*   **200** _Transformer Collection_ Response body for list of personalization transformers.
    
    Media type: `application/json`. Schema: `TransformerCollection`.
    
    _Example: example\_1_ Transformer Collection
    
    ```
    {
      "totalSize": 2,
      "transformers": [
        {
          "id": "0H0xx0000004ABCAA",
          "name": "MyTransformer",
          "label": "My Transformer",
          "description": "Sample transformer",
          "isEnabled": true,
          "channel": "WebApp"
        }
      ],
      "currentPageUrl": "https://yourInstance.salesforce.com/services/data/v66.0/personalization/external-apps/transformers?limit=50&offset=0",
      "nextPageUrl": null
    }
    ```
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for GET (collection) and POST
# methods.

https://yourInstance.salesforce.com/services/data/v67.0/personalization/external-apps/transformers?limit=50&offset=0&source=Organization
```

### POST Personalization Transformers

`POST /personalization/external-apps/transformers`

Operation ID: `createTransformers`. Tags: Personalization Transformers Resources.

The api resource for getting and creating transformers.

Create Personalization Transformers.

_Available in: v66.0_

#### Request body

Request body for creating or updating a Personalization Transformer.

Media type: `application/json`. Schema: `TransformerInput`.

_Example example\_1: same as PUT /personalization/external-apps/transformer request._ Payload 1

_Example: example\_1_ Payload 1

#### Responses

*   **200** _Transformer_ Response body for a single personalization transformer.
    
    Media type: `application/json`. Schema: `Transformer`.
    

#### Code samples

_Example: Example 1 · HTTP_

```
# This example shows a sample resource applicable for GET (collection) and POST
# methods.

https://yourInstance.salesforce.com/services/data/v67.0/personalization/external-apps/transformers?limit=50&offset=0&source=Organization
Content-Type: application/json

{
  "name": "MyTransformer",
  "label": "My Transformer",
  "description": "Handlebars transformer for web content",
  "dataConnectors": [
    "connectorId1"
  ],
  "channel": "WebApp",
  "isEnabled": true,
  "transformerType": "Handlebars",
  "substitutionDefinitions": {
    "titleKey": {
      "label": "Banner title",
      "configType": "Static",
      "defaultValue": "Welcome",
      "overridable": true,
      "required": false
    }
  },
  "transformerTypeDetails": {
    "html": "<div>{{content}}</div>",
    "disableAutoInjectionOfEngagementAttributes": false,
    "script": "",
    "componentName": ""
  }
}
```

## Schemas

### ABnExperimentInput

ABn Experiment Input Representation

*   `chanceToWinThreshold` (_number (double)_)
    
    Winning threshold (85.00–100.00).
    
    _Available in: v65.0_
    
*   `cohorts` (_array of array of PersonalizationAttributeValueInput_, required)
    
    List of ABn Experiment Cohorts.
    
    _Available in: v65.0_
    
*   `criteria` (_string_)
    
    JSON defining targeting or segmentation rules.
    
    _Available in: v65.0_
    
*   `dataSpaceName` (_string_, required)
    
    The API name of the personalization point's data space.
    
    _Available in: v65.0_
    
*   `description` (_string_)
    
    An optional description for the experiment.
    
    _Available in: v65.0_
    
*   `label` (_string_, required)
    
    The experiment's UI label.
    
    _Available in: v65.0_
    
*   `maximumDurationInMinutes` (_integer_)
    
    Maximum duration in minutes (min: `minimumDurationInMinutes` , max: 129600). Ignored if `winnerSelectionMode` is manual.
    
    _Available in: v65.0_
    
*   `minimumDurationInMinutes` (_integer_)
    
    Minimum duration in minutes (60–129600). Ignored if `winnerSelectionMode` is manual.
    
    _Available in: v65.0_
    
*   `minimumRequiredParticipants` (_integer_)
    
    Minimum required participants (300–5000). Ignored if `winnerSelectionMode` is manual.
    
    _Available in: v65.0_
    
*   `name` (_string_, required)
    
    The experiment's API name.
    
    _Available in: v65.0_
    
*   `parameters` (_array of ParameterValueInput_)
    
    Required engagement signal parameters.
    
    _Available in: v65.0_
    
*   `primaryMetrics` (_array of PrimaryMetricReferenceInput_)
    
    Primary metrics for evaluating experiment performance and success.
    
    _Available in: v65.0_
    
*   `profileDataGraphName` (_string_)
    
    The API name of the profile data graph.
    
    _Available in: v65.0_
    
*   `scheduleFrequencyInMinutes` (_integer_)
    
    Processing frequency in minutes (30–1440).
    
    _Available in: v65.0_
    
*   `schemaEnum` (_PersonalizationSchemaEnum_)
*   `schemaName` (_string_, required)
    
    API name of the personalization schema. The data space prefix must match `dataSpaceName` .
    
    _Available in: v65.0_
    
*   `secondaryMetrics` (_array of MetricReferenceInput_)
    
    Metrics for additional performance and behavior insights.
    
    _Available in: v65.0_
    
*   `source` (_object_, required)
    
    PersonalizationSourceEnum
    
    The Experiment’s source.
    
    _Available in: v65.0_
    
    Includes all fields of `PersonalizationSourceEnum`.
    
*   `sourceRecordId` (_string_)
    
    Reference to the origin record, such as a Flow. Generates an edit link when combined with the source enum.
    
    _Available in: v65.0_
    
*   `winnerSelectionMode` (_object_)
    
    WinnerSelectionModeEnum
    
    Winner selection mode: automatic or manual.
    
    _Available in: v65.0_
    
    Includes all fields of `WinnerSelectionModeEnum`.
    

### ABnExperiment

Contains details of a personalization Experiment.

**Note**: This representation inherits properties from Personalization Experiment Named Base.

*   `chanceToWinThreshold` (_number (double)_) Threshold used to declare a winner
*   `cohorts` (_array of ABnExperimentCohort_)
    
    The list of experiment cohorts.
    
    _Available in: v65.0_
    
*   `createdById` (_string (Id)_) Created by id
*   `createdDate` (_string (date-time)_) Created date
*   `criteria` (_object_)
    
    Criteria
    
    Targeting and segmentation rules.
    
    _Available in: v65.0_
    
    Includes all fields of `Criteria`.
    
*   `dataSpaceName` (_string_)
    
    The API name of the experiment's data space.
    
    _Available in: v65.0_
    
*   `description` (_string_) Experiment description
*   `id` (_string (Id)_) The 18 character ID of the record
*   `isRemote` (_boolean_) Is Remote
*   `label` (_string_) Personalization base output label
*   `lastAnalyzed` (_string (date-time)_) When the experiment was last analyzed
*   `lastModifiedById` (_string (Id)_) Last modified by id
*   `lastModifiedDate` (_string (date-time)_) Last modified date
*   `maximumDurationInMinutes` (_integer_) Maximum duration of the experiment in minutes
*   `minimumDurationInMinutes` (_integer_) Minimum duration of the experiment in minutes
*   `minimumRequiredParticipants` (_integer_) Minimum number of participants required for each cohort
*   `name` (_string_) Personalization base output API name
*   `parameters` (_array of ParameterValue_) List of Parameters associated with the Experiment
*   `primaryMetric` (_object_)
    
    PersonalizationExperimentMetricReference
    
    Primary metric for evaluating experiment performance.
    
    _Available in: v65.0_
    
    Includes all fields of `PersonalizationExperimentMetricReference`.
    
*   `primaryMetrics` (_array of PrimaryMetricReference_) The primary metrics of this experiment
*   `profileDataGraphName` (_string_)
    
    The API name of the profile data graph.
    
    _Available in: v65.0_
    
*   `scheduleFrequencyInMinutes` (_integer_) How frequently the experiment analytics should be processed
*   `schemaEnum` (_PersonalizationSchemaEnum_)
*   `schemaName` (_string_)
    
    The API name of the personalization schema. If the name includes a data space prefix, it must match `dataSpaceName` .
    
    _Available in: v65.0_
    
*   `secondaryMetrics` (_array of MetricReference_)
    
    Metrics for additional performance and behavior insights.
    
    _Available in: v65.0_
    
*   `source` (_object_)
    
    PersonalizationSourceEnum
    
    The Experiment's source.
    
    _Available in: v65.0_
    
    Includes all fields of `PersonalizationSourceEnum`.
    
*   `sourceRecordId` (_string_) A record which created this Experiment and which is responsible for maintaining it. What type of object this is depends on the Source.
*   `sourceReferenceId` (_string (Id)_)
    
    Reference to the origin record. Generates an edit link when combined with the source enum.
    
    _Available in: v65.0_
    
*   `startedDate` (_string (date-time)_)
    
    The date and time the experiment started.
    
    _Available in: v65.0_
    
*   `state` (_object_)
    
    ExperimentStateEnum
    
    The Experiment's state.
    
    _Available in: v65.0_
    
    Includes all fields of `ExperimentStateEnum`.
    
*   `status` (_object_)
    
    EntityStatusEnum
    
    The Experiment's status.
    
    _Available in: v65.0_
    
    Includes all fields of `EntityStatusEnum`.
    
*   `stoppedDate` (_string (date-time)_)
    
    The date and time the experiment stopped.
    
    _Available in: v65.0_
    
*   `url` (_string (url)_) Url
*   `winnerSelectionMode` (_WinnerSelectionModeEnum_)

### BatchDecisionCollection

Personalization Batch Decision Collection Output Representation

*   `batchDecisions` (_array of BatchDecision_) List of personalization batch decisions
*   `currentPageUrl` (_string (url)_) Current page url
*   `nextPageUrl` (_string (url)_) Next page url if it exists
*   `totalSize` (_integer_) Total size of collection

### BatchDecisionInput

Personalization Batch Decision Input Representation

*   `activationTriggerType` (_PersonalizationBatchDecisionActivationTriggerTypeEnum_)
*   `batchStatus` (_PersonalizationBatchDecisionStatusEnum_)
*   `dataSpaceName` (_string_) The API name of the Data Space associated with the Personalization Batch Decision
*   `description` (_string_) Personalization Base description
*   `label` (_string_) Personalization Base label
*   `marketSegmentName` (_string_) The API name of the market segment associated with the Personalization Batch Decision
*   `name` (_string_) Personalization Point API name
*   `personalizationKeyFields` (_array of PersonalizationFieldTypeEnum_) The list of key field types associated with the Personalization Batch Decision
*   `personalizationPointNames` (_array of string_) The list of personalization point API names associated with the Personalization Batch Decision
*   `refreshMode` (_DataExportRefreshModeEnum_)

### BatchDecision

Personalization Batch Decision Output Representation

*   `activationTriggerType` (_PersonalizationBatchDecisionActivationTriggerTypeEnum_)
*   `batchStatus` (_PersonalizationBatchDecisionStatusEnum_)
*   `createdById` (_string (Id)_) Created by id
*   `createdDate` (_string (date-time)_) Created date
*   `dataSpace` (_PersonalizationReference_)
*   `description` (_string_) Personalization Batch Decision description
*   `id` (_string (Id)_) The 18 character ID of the record
*   `inputDataModelObject` (_PersonalizationReference_)
*   `isRemote` (_boolean_) Is Remote
*   `label` (_string_) Personalization base output label
*   `lastModifiedById` (_string (Id)_) Last modified by id
*   `lastModifiedDate` (_string (date-time)_) Last modified date
*   `lastRefreshDate` (_string (date-time)_) When the job last ran off-core
*   `lastRefreshErrorCode` (_PersonalizationBatchDecisionErrorCodeOffCoreEnum_)
*   `lastRefreshStatus` (_PersonalizationBatchDecisionLastRefreshStatusEnum_)
*   `lastSuccessfulRefreshDate` (_string (date-time)_) Last successful refreshed date that happened off-core
*   `marketSegment` (_PersonalizationReference_)
*   `modelRevision` (_integer_) Model revision increases everytime batch decision is updated
*   `name` (_string_) Personalization base output API name
*   `outputDataModelObject` (_PersonalizationReference_)
*   `personalizationKeyFields` (_array of PersonalizationFieldTypeEnum_) List of personalization key field types associated with personalization batch decision
*   `personalizationPoints` (_array of string_) List of API names of personalization points associated with personalization batch decision
*   `refreshMode` (_DataExportRefreshModeEnum_)
*   `status` (_EntityStatusEnum_)
*   `url` (_string (url)_) Url

### BatchDecisionPatchInput

Personalization Batch Decision Patch Input Representation

*   `batchStatus` (_PersonalizationBatchDecisionStatusEnum_)
*   `description` (_string_) Personalization Base description
*   `label` (_string_) Personalization Base label
*   `name` (_string_) Personalization Point API name
*   `runBatchPersonalization` (_boolean_) Flag to determine whether to run batch personalization

### BatchDecisionJobCollection

Batch Decision Job Collection Output Representation

*   `currentPageUrl` (_string (url)_) URL of the current page
*   `jobs` (_array of BatchDecisionJob_) List of jobs
*   `lastEvaluatedKey` (_string_) Last evaluated key. Pass this value to receive the next page.
*   `nextPageUrl` (_string (url)_) URL of the next page, or null if there is no next page

### CalculatedAffinityCollection

Calculated Affinity Collection Output Representation

*   `calculatedAffinities` (_array of CalculatedAffinity_) List of calculated affinities
*   `currentPageUrl` (_string (url)_) Current page url
*   `nextPageUrl` (_string (url)_) Next page url if it exists
*   `totalSize` (_integer_) Total size of collection

### CalculatedAffinityInput

Calculated Affinity Input Representation

*   `contentObjectFieldNames` (_array of string_) The Content Object field names to compare this calculated affinity model against
*   `contentObjectName` (_string_) The name of the Content Object
*   `dataSpaceName` (_string_) The API name of the Data Space associated with this affinity
*   `description` (_string_) Personalization Base description
*   `engagementSignals` (_array of CalculatedAffinityEngagementSignalInput_) A collection of user interactions with their strength and impact, such as product views and purchases, used to determine a user's affinity for specific brands or products, with more recent and purchase-related engagements contributing higher to the affinity score
*   `isDecay` (_boolean_) Whether decay is enabled
*   `label` (_string_) Personalization Base label
*   `lookBackWindow` (_integer_) The time frame in days the model should consider when computing affinity
*   `name` (_string_) Personalization Point API name
*   `profileDataGraphName` (_string_) The name of the Profile Data Graph
*   `scoringModel` (_ScoringModelEnum_)

### CalculatedAffinity

Calculated Affinity Output Representation

*   `contentObjectFieldNames` (_array of string_) The field names of the Content Object used to compare affinity against
*   `contentObjectName` (_string_) The name of the Content Object
*   `createdById` (_string (Id)_) Created by id
*   `createdDate` (_string (date-time)_) Created date
*   `dataSpaceName` (_string_) The API name of the Data Space associated with the Calculated Affinity
*   `description` (_string_) Description of the Calculated Affinity
*   `engagementSignals` (_array of CalculatedAffinityEngagementSignal_) The interaction signals with their strength and impact used for computing affinity
*   `id` (_string (Id)_) The 18 character ID of the record
*   `isDecay` (_boolean_) Whether decay is enabled
*   `label` (_string_) Personalization base output label
*   `lastModifiedById` (_string (Id)_) Last modified by id
*   `lastModifiedDate` (_string (date-time)_) Last modified date
*   `lookBackWindow` (_integer_) The time frame in days the model should consider when computing affinity
*   `name` (_string_) Personalization base output API name
*   `profileDataGraphName` (_string_) The name of the Profile Data Graph
*   `scoringModel` (_ScoringModelEnum_)
*   `url` (_string (url)_) Url

### PersonalizationExperienceConfigCollection

Personalization Experience Config Collection Output Representation

*   `currentPageUrl` (_string (url)_) Current page url
*   `nextPageUrl` (_string (url)_) Next page url if it exists
*   `personalizationExperienceConfigs` (_array of PersonalizationExperienceConfig_) List of Personalization Experience Configs
*   `totalSize` (_integer_) Total size of collection

### PersonalizationExperienceConfigInput

Personalization Experience Config Input Representation

*   `createdById` (_string_) Id of the user who created this Personalization Experience Config (read-only, ignored on input)
*   `createdDate` (_string (date-time)_) The datetime when this Personalization Experience Config was created (read-only, ignored on input)
*   `dataProvider` (_DataProviderInput_)
*   `description` (_string_) Description of the Personalization Experience Config
*   `displayUrl` (_string_) When editing this configuration on the Website which page of the website should this configuration be displayed on if not the current page.
*   `id` (_string_) Id of the Personalization Experience Config (read-only, ignored on input)
*   `isEnabled` (_boolean_) Whether or not this particular configuration is enabled.
*   `label` (_string_) Label of the Personalization Experience Config
*   `lastModifiedById` (_string_) Id of the user who last modified this Personalization Experience Config (read-only, ignored on input)
*   `lastModifiedDate` (_string (date-time)_) The datetime when this Personalization Experience Config was last modified.
*   `name` (_string_) Name of the Personalization Experience Config
*   `publishedDate` (_string (date-time)_) The datetime when this Personalization Experience Config was last published.
*   `sourceMatchers` (_array of SourceMatcherInput_) How to find the source where this personalization will occur which for web is which web pages.
*   `transformationConfig` (_array of TransformationInput_) How will the data provided by the Data Provider be transformed?

### PersonalizationExperienceConfig

Personalization Experience Config Output Representation

*   `createdById` (_string (Id)_) Id of the user who created this Personalization Experience Config
*   `createdDate` (_string (date-time)_) The datetime when this Personalization Experience Config was created.
*   `dataProvider` (_DataProvider_)
*   `description` (_string_) Description of the Personalization Experience Config
*   `displayUrl` (_string_) When editing this configuration on the Website which page of the website should this configuration be displayed on if not the current page.
*   `id` (_string (Id)_) Id of the Personalization Experience Config
*   `isEnabled` (_boolean_) Whether or not this particular configuration is enabled.
*   `label` (_string_) Label of the Personalization Experience Config
*   `lastModifiedById` (_string (Id)_) Id of the user who last modified this Personalization Experience Config
*   `lastModifiedDate` (_string (date-time)_) The datetime when this Personalization Experience Config was last modified.
*   `name` (_string_) Name of the Personalization Experience Config
*   `publishedDate` (_string (date-time)_) The datetime when this Personalization Experience Config was last published.
*   `sourceMatchers` (_array of SourceMatcher_) How to find the source where this personalization will occur which for web is which web pages.
*   `transformationConfig` (_TransformationConfig_)
*   `wpmUrl` (_string (url)_) Customer website URL with authURL and wpm parameter as query param

### PersonalizationPointInput

This representation defines the settings for creating or updating a personalization point.

*   `abnExperimentName` (_string_)
    
    API name of a Personalization Experiment that the personalization point is part of.
    
    _Available in: v65.0_
    
*   `dataSpaceName` (_string_)
    
    API name of the data space where this personalization point resides.
    
    _Available in: v64.0_
    
*   `decisions` (_array of PersonalizationDecisionInput_)
    
    List of personalization decision definitions.
    
    _Available in: v64.0_
    
*   `description` (_string_)
    
    Optional description of the personalization point.
    
    _Available in: v64.0_
    
*   `isAuthenticationRequired` (_boolean_)
    
    Whether the end user must be authenticated at runtime. Defaults to false prior to v66.0.
    
    _Available in: v66.0_
    
*   `label` (_string_)
    
    Display label that appears in the user interface.
    
    _Available in: v64.0_
    
*   `maxItemsCount` (_integer_)
    
    Maximum number of content items to return at runtime. Defaults to 12 for recommendation type personalization content schemas.
    
    _Available in: v64.0_
    
*   `name` (_string_)
    
    API name of the personalization point.
    
    _Available in: v64.0_
    
*   `profileDataGraphName` (_string_)
    
    API name of the profile data graph for this personalization point. This value is optional unless decisions use targeting rules that reference profile attributes.
    
    _Available in: v64.0_
    
*   `rootPersonalizationPointId` (_string_)
    
    ID of the root Personalization Point (for derived points).
    
    _Available in: v64.0_
    
*   `schemaName` (_string_)
    
    API name of a personalization content schema assigned to this personalization point. You can use this field, or the schemaEnum, but not both.
    
    _Available in: v64.0_
    
*   `sourceRecordId` (_string_)
    
    ID of the record responsible for maintaining this personalization point.
    
    _Available in: v64.0_
    
*   `schemaEnum` (_object_)
    
    Standard personalization content schema type. Use this string, or the schemaName, but not both.
    
    _Available in: v64.0_
    
    Includes all fields of `PersonalizationSchemaEnum`.
    
*   `source` (_object_)
    
    Application used to create this personalization point.
    
    _Available in: v64.0_
    
    Includes all fields of `PersonalizationSourceEnum`.
    

### PersonalizationPoint

Contains detailed output information for a personalization point.

*   `abnExperimentName` (_string_)
    
    API name of a personalization experiment that the personalization point is part of.
    
    _Available in: v65.0_
    
*   `createdById` (_string (Id)_)
    
    ID of the user who created the personalization point.
    
    _Available in: v64.0_
    
*   `createdDate` (_string (date-time)_)
    
    Timestamp of when the personalization point was created.
    
    _Available in: v64.0_
    
*   `dataSpaceName` (_string_)
    
    API name of the data space where this personalization point resides.
    
    _Available in: v64.0_
    
*   `decisions` (_array of PersonalizationDecision_)
    
    List of personalization decision definitions.
    
    _Available in: v64.0_
    
*   `description` (_string_)
    
    Optional description of the personalization point.
    
    _Available in: v64.0_
    
*   `id` (_string (Id)_)
    
    Salesforce personalization point record ID.
    
    _Available in: v64.0_
    
*   `isAuthenticationRequired` (_boolean_)
    
    Whether authentication is required at runtime.
    
    _Available in: v66.0_
    
*   `label` (_string_)
    
    Display label that appears for the personalization point in the user interface.
    
    _Available in: v64.0_
    
*   `lastModifiedById` (_string (Id)_)
    
    ID of the user who last modified the record.
    
    _Available in: v64.0_
    
*   `lastModifiedDate` (_string (date-time)_)
    
    Timestamp of when the personalization point was last modified.
    
    _Available in: v64.0_
    
*   `maxItemsCount` (_integer_)
    
    Maximum number of personalized content items returned at runtime.
    
    _Available in: v64.0_
    
*   `name` (_string_)
    
    API name of the personalization point.
    
    _Available in: v64.0_
    
*   `profileDataGraphName` (_string_)
    
    API name of the profile data graph for this personalization point.
    
    _Available in: v64.0_
    
*   `rootPersonalizationPointId` (_string_)
    
    ID of the root personalization point (for derived points).
    
    _Available in: v64.0_
    
*   `schemaName` (_string_)
    
    API name of the personalization content schema assigned to this personalization point.
    
    _Available in: v64.0_
    
*   `sourceRecordId` (_string_)
    
    ID of the record responsible for maintaining this personalization point.
    
    _Available in: v64.0_
    
*   `url` (_string (url)_)
    
    The relative path to the server for this resource (for example, /services/data/v67.0/personalization/personalization-points/{name}).
    
    _Available in: v64.0_
    
*   `schemaEnum` (_object_)
    
    Standard personalization schema type, if applicable.
    
    _Available in: v64.0_
    
    Includes all fields of `PersonalizationSchemaEnum`.
    
*   `source` (_object_)
    
    Application used to create this personalization point.
    
    _Available in: v64.0_
    
    Includes all fields of `PersonalizationSourceEnum`.
    
*   `status` (_object_)
    
    Status of the personalization point.
    
    _Available in: v64.0_
    
    Includes all fields of `EntityStatusEnum`.
    

### PersonalizationRecommenderCollection

Contains a collection of personalization recommenders.

*   `data` (_array of PersonalizationRecommender_)
    
    A collection of personalization recommenders.
    
    _Available in: v64.0_
    

### PersonalizationRecommenderInput

Contains the details for creating a personalization recommender.

**Note**: This representation inherits properties from the Personalization Recommender Base Input.

*   `backupRecommenderName` (_string_) The API name (developerName) of the backup recommender to use when primary recommender returns insufficient recommendation results.
*   `chanceToLoseThreshold` (_number (double)_) Threshold used to declare a losing variant.
*   `chanceToWinThreshold` (_number (double)_) Threshold used to declare a winning variant.
*   `dataSpaceName` (_string_, required)
    
    The name of the data space for the recommender.
    
    _Available in: v64.0_
    
*   `decisionOptions` (_array of PersonalizationRecommenderDecisionOptionInput_) Decision options (arms) of this contextual bandit recommender.
*   `description` (_string_) Personalization Base description
*   `excludeFilters` (_array of BaseRuleInput_)
    
    The exclusion filters for the recommender.
    
    _Available in: v64.0_
    
*   `includeFilters` (_array of BaseRuleInput_)
    
    The inclusion filters for the recommender.
    
    _Available in: v64.0_
    
*   `itemDataGraphName` (_string_, required)
    
    The name of the item data graph for the recommender.
    
    _Available in: v64.0_
    
*   `label` (_string_) Personalization Base label
*   `minimumRequiredParticipants` (_integer_) Minimum number of participants required for evaluation.
*   `name` (_string_) Personalization Point API name
*   `objectiveName` (_string_)
    
    The custom objective for the recommender.
    
    _Available in: v64.0_
    
*   `profileDataGraphName` (_string_, required)
    
    The name of the profile data graph for the recommender.
    
    _Available in: v64.0_
    
*   `scheduleFrequencyInMinutes` (_integer_) How frequently recommender analytics should be processed, in minutes.
*   `sortCriteria` (_object_)
    
    PersonalizationRecommenderSortCriteria
    
    The sort order for rule-based recommenders.
    
    _Available in: v64.0_
    
    Includes all fields of `PersonalizationRecommenderSortCriteria`.
    
*   `sourceRecordId` (_string (Id)_) The FlowRecordElement or ManagedContent record that owns or created this recommender.
*   `state` (_RecommenderStateEnum_)

### PersonalizationRecommender

Contains details of a personalization recommender.

**Note**: This representation inherits properties from Personalization Recommender Named Base.

*   `backupRecommender` (_PersonalizationReference_)
*   `chanceToLoseThreshold` (_number (double)_) Threshold used to declare a losing variant.
*   `chanceToWinThreshold` (_number (double)_) Threshold used to declare a winning variant.
*   `contentObject` (_object_)
    
    PersonalizationReference
    
    The content object used by the recommender.
    
    _Available in: v64.0_
    
    Includes all fields of `PersonalizationReference`.
    
*   `createdById` (_string (Id)_) Created by id
*   `createdDate` (_string (date-time)_) Created date
*   `dataSpace` (_object_)
    
    PersonalizationReference
    
    The data space used by the recommender.
    
    _Available in: v64.0_
    
    Includes all fields of `PersonalizationReference`.
    
*   `decisionOptions` (_array of PersonalizationRecommenderDecisionOption_) Decision options (arms) of this contextual bandit recommender. Returned only on filter=Big.
*   `excludeFilters` (_object_)
    
    RuleGroup
    
    The exclusion filter for the recommender.
    
    _Available in: v64.0_
    
    Includes all fields of `RuleGroup`.
    
*   `id` (_string (Id)_) The 18 character ID of the record
*   `includeFilters` (_object_)
    
    RuleGroup
    
    The inclusion filter for the recommender.
    
    _Available in: v64.0_
    
    Includes all fields of `RuleGroup`.
    
*   `isRemote` (_boolean_) Indicates if the recommender is remote.
*   `itemDataGraph` (_object_)
    
    PersonalizationReference
    
    The item data graph used by the recommender.
    
    _Available in: v64.0_
    
    Includes all fields of `PersonalizationReference`.
    
*   `label` (_string_) Personalization base output label
*   `lastModifiedById` (_string (Id)_) Last modified by id
*   `lastModifiedDate` (_string (date-time)_) Last modified date
*   `lastRefreshedStatus` (_object_)
    
    LatestRefreshedStatusEnum
    
    The status of the last refresh.
    
    _Available in: v64.0_
    
    Includes all fields of `LatestRefreshedStatusEnum`.
    
*   `lastSuccessfulRefresh` (_string (date-time)_)
    
    The time when the last successful refresh happened.
    
    _Available in: v64.0_
    
*   `minimumRequiredParticipants` (_integer_) Minimum number of participants required for evaluation.
*   `name` (_string_) Personalization base output API name
*   `objective` (_object_)
    
    PersonalizationReference
    
    The objective of the recommender.
    
    _Available in: v64.0_
    
    Includes all fields of `PersonalizationReference`.
    
*   `profileDataGraph` (_object_)
    
    PersonalizationReference
    
    The profile data graph used by the recommender.
    
    _Available in: v64.0_
    
    Includes all fields of `PersonalizationReference`.
    
*   `scheduleFrequencyInMinutes` (_integer_) How frequently recommender analytics should be processed, in minutes.
*   `sortCriteria` (_object_)
    
    SortCriteria
    
    The sort criteria for the recommender.
    
    _Available in: v64.0_
    
    Includes all fields of `SortCriteria`.
    
*   `sourceRecordId` (_string (Id)_) The FlowRecordElement or ManagedContent record that owns or created this recommender.
*   `state` (_RecommenderStateEnum_)
*   `status` (_object_)
    
    EntityStatusEnum
    
    The status of the recommender.
    
    _Available in: v64.0_
    
    Includes all fields of `EntityStatusEnum`.
    
*   `url` (_string (url)_) Url

### PersonalizationRecommenderPatchInput

Contains the details for editing a personalization recommender.

**Note**: This representation inherits properties from the Personalization Recommender Base Patch Input.

*   `backupRecommenderName` (_string_) The API name (developerName) of the backup recommender to use when primary recommender returns insufficient recommendation results.
*   `chanceToLoseThreshold` (_number (double)_) Threshold used to declare a losing variant.
*   `chanceToWinThreshold` (_number (double)_) Threshold used to declare a winning variant.
*   `decisionOptions` (_array of PersonalizationRecommenderDecisionOptionInput_) Decision options (arms) of this contextual bandit recommender. Reconciles by name: matched options are updated, unmatched incoming options are created, unmatched existing options are deleted (cascade).
*   `description` (_string_) Description of the entity.
*   `excludeFilters` (_array of BaseRuleInput_)
    
    The filters applied before rendering recommendations to decide items to exclude.
    
    _Available in: v65.0_
    
*   `includeFilters` (_array of BaseRuleInput_)
    
    The filters applied before rendering recommendations to decide items to include.
    
    _Available in: v65.0_
    
*   `label` (_string_) Label of the entity.
*   `minimumRequiredParticipants` (_integer_) Minimum number of participants required for evaluation.
*   `scheduleFrequencyInMinutes` (_integer_) How frequently recommender analytics should be processed, in minutes.
*   `state` (_RecommenderStateEnum_)

### PersonalizationRecommenderJobCollection

Contains a collection of personalization recommender jobs.

*   `currentPageUrl` (_string (url)_)
    
    The URL for the current page of results.
    
    _Available in: v63.0_
    
*   `jobs` (_array of PersonalizationRecommenderJob_)
    
    A collection of personalization recommender jobs.
    
    _Available in: v63.0_
    
*   `nextPageUrl` (_string (url)_)
    
    The URL for the next page of results, if one exists.
    
    _Available in: v63.0_
    

### PersonalizationSchemaInput

Contains the details for creating or updating a personalization content schema.

*   `attributes` (_array of PersonalizationAttributeInput_)
    
    List of personalization attributes associated with the content schema.
    
    _Available in: v65.0_
    
*   `dataSpaceName` (_string_)
    
    The API name of the data space associated with the personalization content schema.
    
    _Available in: v65.0_
    
*   `description` (_string_)
    
    A description of the personalization content schema.
    
    _Available in: v65.0_
    
*   `label` (_string_)
    
    The display label for the personalization content schema.
    
    _Available in: v65.0_
    
*   `name` (_string_)
    
    The API name of the personalization content schema.
    
    _Available in: v65.0_
    
*   `relatedContentObjects` (_array of PersonalizationRelatedContentObjectInput_)
    
    List of related content objects. These are DMOs related to the primary content object whose fields are also included in the runtime response.
    
    _Available in: v65.0_
    
*   `personalizationType` (_object_)
    
    The type of the personalization schema.
    
    _Available in: v65.0_
    
    Includes all fields of `PersonalizationTypeEnum`.
    
*   `contentObject` (_object_)
    
    Information about the content DMO fields returned as content at runtime.
    
    _Available in: v65.0_
    
    Includes all fields of `PersonalizationContentObjectInput`.
    

### PersonalizationSchema

Contains details of a personalization content schema.

*   `attributes` (_array of PersonalizationAttribute_)
    
    List of personalization attributes associated with the schema.
    
    _Available in: v65.0_
    
*   `createdById` (_string (Id)_)
    
    The ID of the user who created the personalization content schema.
    
    _Available in: v65.0_
    
*   `createdDate` (_string (date-time)_)
    
    The date and time when the personalization content schema was created.
    
    _Available in: v65.0_
    
*   `dataSpaceName` (_string_)
    
    The API name of the data space associated with the personalization content schema.
    
    _Available in: v65.0_
    
*   `description` (_string_)
    
    A description of the personalization content schema.
    
    _Available in: v65.0_
    
*   `id` (_string (Id)_)
    
    The unique identifier for the personalization content schema.
    
    _Available in: v65.0_
    
*   `label` (_string_)
    
    The display label for the personalization content schema.
    
    _Available in: v65.0_
    
*   `lastModifiedById` (_string (Id)_)
    
    The ID of the user who last modified the personalization content schema.
    
    _Available in: v65.0_
    
*   `lastModifiedDate` (_string (date-time)_)
    
    The date and time when the personalization content schema was last modified.
    
    _Available in: v65.0_
    
*   `name` (_string_)
    
    The API name of the personalization content schema.
    
    _Available in: v65.0_
    
*   `relatedContentObjects` (_array of PersonalizationRelatedContentObject_)
    
    List of related content objects.
    
    _Available in: v65.0_
    
*   `url` (_string (url)_)
    
    The API URL for this personalization content schema resource.
    
    _Available in: v65.0_
    
*   `personalizationType` (_object_)
    
    The type of the personalization content schema.
    
    _Available in: v65.0_
    
    Includes all fields of `PersonalizationTypeEnum`.
    
*   `contentObject` (_object_)
    
    The content object information.
    
    _Available in: v65.0_
    
    Includes all fields of `PersonalizationContentObject`.
    

### EngagementSignalCompoundMetricInput

Engagement Signal Compound Metric Input Representation

*   `denominatorMetric` (_object_, required)
    
    EngagementSignalMetricFieldInput
    
    The Engagement Signal Metric used as the secondary operand.
    
    _Available in: v64.0_
    
    Includes all fields of `EngagementSignalMetricFieldInput`.
    
*   `description` (_string_)
    
    Description of the compound metric.
    
    _Available in: v64.0_
    
*   `label` (_string_, required)
    
    Label for the compound metric.
    
    _Available in: v64.0_
    
*   `name` (_string_, required)
    
    API name for the compound metric.
    
    _Available in: v64.0_
    
*   `numeratorMetric` (_object_, required)
    
    EngagementSignalMetricFieldInput
    
    The Engagement Signal Metric used as the primary operand.
    
    _Available in: v64.0_
    
    Includes all fields of `EngagementSignalMetricFieldInput`.
    
*   `operator` (_object_, required)
    
    EngagementSignalCompoundMetricOperatorEnum
    
    Operator between the two metrics.
    
    _Available in: v64.0_
    
    Includes all fields of `EngagementSignalCompoundMetricOperatorEnum`.
    

### EngagementSignalCompoundMetric

Response body for an Engagement Signal Compound Metric.

*   `denominatorMetric` (_object_)
    
    EngagementSignalMetricField
    
    The Engagement Signal Metric used as the secondary operand.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
    Includes all fields of `EngagementSignalMetricField`.
    
*   `description` (_string_)
    
    Description of the compound metric.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
*   `id` (_string (Id)_)
    
    ID of the compound metric.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
*   `label` (_string_)
    
    Label for the compound metric.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
*   `name` (_string_)
    
    API name for the compound metric.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
*   `numeratorMetric` (_object_)
    
    EngagementSignalMetricField
    
    The Engagement Signal Metric used as the primary operand.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
    Includes all fields of `EngagementSignalMetricField`.
    
*   `operator` (_object_)
    
    EngagementSignalCompoundMetricOperatorEnum
    
    Operator between the two metrics.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
    Includes all fields of `EngagementSignalCompoundMetricOperatorEnum`.
    
*   `createdById` (_string (Id)_)
    
    Created by ID of the Compound Metric.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
*   `createdDate` (_string (date)_)
    
    Creation date of the Compound Metric.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
*   `lastModifiedById` (_string (Id)_)
    
    Last modified ID of the Compound Metric.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
*   `lastModifiedDate` (_string (date)_)
    
    Last modified date of the Compound Metric.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
*   `url` (_string_)
    
    Connect URL to this resource.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    

### EngagementSignalCollection

List of Engagement Signals.

This representation extends `CdpPaginatedResponseBaseRepresentation`. For inherited pagination fields, see [Paginated Response Base Output](https://developer.salesforce.com/docs/data/connectapi/references/spec?meta=type%3APaginated%2BResponse%2BBase%2BOutput).

*   `currentPageUrl` (_string (url)_) Current page url
*   `engagementSignals` (_array of EngagementSignal_)
    
    List of Engagement Signals.
    
    _Available in: v63.0_
    
    _Filter group: Small_
    
*   `nextPageUrl` (_string (url)_) Next page url if it exists
*   `totalSize` (_integer_) Total size of collection

### EngagementSignalInput

Engagement Signal Input Representation

*   `catalogIdField` (_object_)
    
    FieldInput
    
    A field on the content object DMO or its related DMO.
    
    _Available in: v63.0_
    
    Includes all fields of `FieldInput`.
    
*   `compoundMetrics` (_array of EngagementSignalCompoundMetricInput_) Engagement Signal Compound Metrics
*   `dataSpaceName` (_string_, required)
    
    The API name of the Data Space associated with the Engagement Signal.
    
    _Available in: v63.0_
    
*   `description` (_string_) Engagement Signal description
*   `distinctFields` (_array of FieldInput_)
    
    Fields on the content object DMO or its related DMOs.
    
    _Available in: v63.0_
    
*   `filterGroups` (_array of EngagementSignalFilterGroupInput_)
    
    Engagement Signal Filter Group Collection.
    
    _Available in: v63.0_
    
*   `joinDimensions` (_array of EngagementSignalJoinDimDefInput_) Engagement Signal Join Dimension Definitions
*   `label` (_string_, required)
    
    The label of the Engagement Signal.
    
    _Available in: v63.0_
    
*   `metrics` (_array of EngagementSignalMetricInput_)
    
    Engagement Signal Metrics.
    
    _Available in: v63.0_
    
*   `name` (_string_, required)
    
    The API name of the Engagement Signal.
    
    _Available in: v63.0_
    
*   `objectName` (_string_, required)
    
    The API name of the Content Object DMO with the Engagement Signal.
    
    _Available in: v63.0_
    
*   `parameters` (_array of EngagementSignalParameterInput_)
    
    Engagement Signal Parameters.
    
    _Available in: v63.0_
    
*   `timestampField` (_object_, required)
    
    FieldInput
    
    DateTime field on the content object DMO or its related DMO.
    
    _Available in: v63.0_
    
    Includes all fields of `FieldInput`.
    
*   `uniqueIdentifier` (_FieldInput_)
*   `userIdField` (_object_, required)
    
    FieldInput
    
    A field on the content object DMO or its related DMO.
    
    _Available in: v63.0_
    
    Includes all fields of `FieldInput`.
    
*   `uniqueIdentifierField` (_object_, required)
    
    EngagementSignalField
    
    A field on the content object DMO or its related DMO.
    
    _Available in: v63.0_
    
    Includes all fields of `EngagementSignalField`.
    

### EngagementSignal

Response body for an Engagement Signal.

*   `catalogIdField` (_object_)
    
    Field
    
    A field on the content object DMO or its related DMO.
    
    _Available in: v63.0_
    
    _Filter group: Small_
    
    Includes all fields of `Field`.
    
*   `compoundMetrics` (_array of EngagementSignalCompoundMetric_) Engagement Signal Compound Metrics
*   `dataSpaceName` (_string_)
    
    The API name of the Data Space associated with the Engagement Signal.
    
    _Available in: v63.0_
    
    _Filter group: Small_
    
*   `description` (_string_) Engagement Signal Description
*   `distinctFields` (_array of Field_)
    
    Fields on the content object DMO or its related DMOs.
    
    _Available in: v63.0_
    
    _Filter group: Big_
    
*   `filterGroups` (_array of EngagementSignalFilterGroup_)
    
    List of filter groups.
    
    _Available in: v63.0_
    
    _Filter group: Big_
    
*   `id` (_string (Id)_)
    
    The platform object ID of the Engagement Signal.
    
    _Available in: v63.0_
    
    _Filter group: Small_
    
*   `joinDimensions` (_array of EngagementSignalJoinDimDef_) Engagement Signal Join Dimension Definitions
*   `label` (_string_)
    
    The label of the Engagement Signal.
    
    _Available in: v63.0_
    
    _Filter group: Small_
    
*   `metrics` (_array of EngagementSignalMetric_)
    
    List of metrics.
    
    _Available in: v63.0_
    
    _Filter group: Medium_
    
*   `name` (_string_)
    
    The API name of the Engagement Signal.
    
    _Available in: v63.0_
    
    _Filter group: Small_
    
*   `objectName` (_string_)
    
    The API name of the Content Object associated with the Engagement Signal.
    
    _Available in: v63.0_
    
    _Filter group: Small_
    
*   `parameters` (_array of EngagementSignalParameter_)
    
    List of parameters.
    
    _Available in: v63.0_
    
    _Filter group: Medium_
    
*   `timestampField` (_object_)
    
    Field
    
    DateTime field on the content object DMO or its related DMO.
    
    _Available in: v63.0_
    
    _Filter group: Small_
    
    Includes all fields of `Field`.
    
*   `uniqueIdentifier` (_object_)
    
    Field
    
    A field on the content object DMO or its related DMO.
    
    _Available in: v63.0_
    
    _Filter group: Small_
    
    Includes all fields of `Field`.
    
*   `userIdField` (_object_)
    
    Field
    
    A field on the content object DMO or its related DMO.
    
    _Available in: v63.0_
    
    _Filter group: Small_
    
    Includes all fields of `Field`.
    

### EngagementSignalMetricInput

Request body for creating an Engagement Signal Metric.

*   `aggregateFunction` (_object_, required)
    
    EngagementSignalMetricAggregateFunctionEnum
    
    Engagement Signal Metric Aggregate Function. The value can be
    
    *   SUM
    *   AVG
    *   COUNT
    *   DISTINCT
    
    _Available in: v64.0_
    
    Includes all fields of `EngagementSignalMetricAggregateFunctionEnum`.
    
*   `description` (_string_) Engagement Signal Metric description
*   `field` (_object_, required)
    
    EngagementSignalField
    
    A field on the content object DMO or its related DMO for the metric calculation.
    
    _Available in: v64.0_
    
    Includes all fields of `EngagementSignalField`.
    
*   `label` (_string_) Engagement Signal Metric label
*   `name` (_string_, required)
    
    The name of the Engagement Signal Metric.
    
    _Available in: v64.0_
    

### EngagementSignalMetric

Response body for an Engagement Signal Metric.

*   `aggregateFunction` (_object_)
    
    EngagementSignalMetricAggregateFunctionEnum
    
    Engagement Signal Metric Aggregate Function Enum.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
    Includes all fields of `EngagementSignalMetricAggregateFunctionEnum`.
    
*   `field` (_object_)
    
    Field
    
    A field on the content object DMO or its related DMO for the metric calculation.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
    Includes all fields of `Field`.
    
*   `id` (_string (Id)_)
    
    ID of the Engagement Signal Metric.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    
*   `name` (_string_)
    
    The name of the Engagement Signal Metric.
    
    _Available in: v64.0_
    
    _Filter group: Small_
    

### Transformer

Response body for a single personalization transformer.

*   `channel` (_object_)
    
    StreamingAppDataConnectorTypeEnum
    
    Specifies whether this transformer is for a website or mobile application. Values are: `{MobileApp}` , `{WebApp}` .
    
    _Available in: v66.0_
    
    _Filter group: Small_
    
    Includes all fields of `StreamingAppDataConnectorTypeEnum`.
    
*   `createdById` (_string_)
    
    ID of the user or process that created this object.
    
    _Available in: v66.0_
    
    _Filter group: Small_
    
*   `createdDate` (_string (date-time)_)
    
    Timestamp when the object was created.
    
    _Available in: v66.0_
    
    _Filter group: Small_
    
*   `dataConnectors` (_array of StreamingAppDataConnector_)
    
    List of websites or mobile apps this personalization transformer belongs to.
    
    _Available in: v66.0_
    
    _Filter group: Small_
    
*   `dataSpace` (_string_)
    
    Name of the data space the transformer belongs to.
    
    _Available in: v66.0_
    
[...]
